<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddDelegatedOwner StructType
 * @subpackage Structs
 */
class AddDelegatedOwner extends AbstractStructBase
{
    /**
     * The guidToUpdate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $guidToUpdate;
    /**
     * The guidToAdd
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $guidToAdd;
    /**
     * The myCred
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Credential
     */
    public $myCred;
    /**
     * Constructor method for AddDelegatedOwner
     * @uses AddDelegatedOwner::setGuidToUpdate()
     * @uses AddDelegatedOwner::setGuidToAdd()
     * @uses AddDelegatedOwner::setMyCred()
     * @param string $guidToUpdate
     * @param string $guidToAdd
     * @param \StructType\Credential $myCred
     */
    public function __construct($guidToUpdate = null, $guidToAdd = null, \StructType\Credential $myCred = null)
    {
        $this
            ->setGuidToUpdate($guidToUpdate)
            ->setGuidToAdd($guidToAdd)
            ->setMyCred($myCred);
    }
    /**
     * Get guidToUpdate value
     * @return string|null
     */
    public function getGuidToUpdate()
    {
        return $this->guidToUpdate;
    }
    /**
     * Set guidToUpdate value
     * @param string $guidToUpdate
     * @return \StructType\AddDelegatedOwner
     */
    public function setGuidToUpdate($guidToUpdate = null)
    {
        // validation for constraint: string
        if (!is_null($guidToUpdate) && !is_string($guidToUpdate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($guidToUpdate)), __LINE__);
        }
        $this->guidToUpdate = $guidToUpdate;
        return $this;
    }
    /**
     * Get guidToAdd value
     * @return string|null
     */
    public function getGuidToAdd()
    {
        return $this->guidToAdd;
    }
    /**
     * Set guidToAdd value
     * @param string $guidToAdd
     * @return \StructType\AddDelegatedOwner
     */
    public function setGuidToAdd($guidToAdd = null)
    {
        // validation for constraint: string
        if (!is_null($guidToAdd) && !is_string($guidToAdd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($guidToAdd)), __LINE__);
        }
        $this->guidToAdd = $guidToAdd;
        return $this;
    }
    /**
     * Get myCred value
     * @return \StructType\Credential|null
     */
    public function getMyCred()
    {
        return $this->myCred;
    }
    /**
     * Set myCred value
     * @param \StructType\Credential $myCred
     * @return \StructType\AddDelegatedOwner
     */
    public function setMyCred(\StructType\Credential $myCred = null)
    {
        $this->myCred = $myCred;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddDelegatedOwner
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
