<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateGroup StructType
 * @subpackage Structs
 */
class CreateGroup extends AbstractStructBase
{
    /**
     * The myGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GUMGroup
     */
    public $myGroup;
    /**
     * The myCred
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Credential
     */
    public $myCred;
    /**
     * Constructor method for CreateGroup
     * @uses CreateGroup::setMyGroup()
     * @uses CreateGroup::setMyCred()
     * @param \StructType\GUMGroup $myGroup
     * @param \StructType\Credential $myCred
     */
    public function __construct(\StructType\GUMGroup $myGroup = null, \StructType\Credential $myCred = null)
    {
        $this
            ->setMyGroup($myGroup)
            ->setMyCred($myCred);
    }
    /**
     * Get myGroup value
     * @return \StructType\GUMGroup|null
     */
    public function getMyGroup()
    {
        return $this->myGroup;
    }
    /**
     * Set myGroup value
     * @param \StructType\GUMGroup $myGroup
     * @return \StructType\CreateGroup
     */
    public function setMyGroup(\StructType\GUMGroup $myGroup = null)
    {
        $this->myGroup = $myGroup;
        return $this;
    }
    /**
     * Get myCred value
     * @return \StructType\Credential|null
     */
    public function getMyCred()
    {
        return $this->myCred;
    }
    /**
     * Set myCred value
     * @param \StructType\Credential $myCred
     * @return \StructType\CreateGroup
     */
    public function setMyCred(\StructType\Credential $myCred = null)
    {
        $this->myCred = $myCred;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
