<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateUserDefaultEmail StructType
 * @subpackage Structs
 */
class CreateUserDefaultEmail extends AbstractStructBase
{
    /**
     * The sendEmailToDelegatedOwners
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $sendEmailToDelegatedOwners;
    /**
     * The gmUser
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GUMUser
     */
    public $gmUser;
    /**
     * The myCred
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Credential
     */
    public $myCred;
    /**
     * Constructor method for CreateUserDefaultEmail
     * @uses CreateUserDefaultEmail::setSendEmailToDelegatedOwners()
     * @uses CreateUserDefaultEmail::setGmUser()
     * @uses CreateUserDefaultEmail::setMyCred()
     * @param bool $sendEmailToDelegatedOwners
     * @param \StructType\GUMUser $gmUser
     * @param \StructType\Credential $myCred
     */
    public function __construct($sendEmailToDelegatedOwners = null, \StructType\GUMUser $gmUser = null, \StructType\Credential $myCred = null)
    {
        $this
            ->setSendEmailToDelegatedOwners($sendEmailToDelegatedOwners)
            ->setGmUser($gmUser)
            ->setMyCred($myCred);
    }
    /**
     * Get sendEmailToDelegatedOwners value
     * @return bool
     */
    public function getSendEmailToDelegatedOwners()
    {
        return $this->sendEmailToDelegatedOwners;
    }
    /**
     * Set sendEmailToDelegatedOwners value
     * @param bool $sendEmailToDelegatedOwners
     * @return \StructType\CreateUserDefaultEmail
     */
    public function setSendEmailToDelegatedOwners($sendEmailToDelegatedOwners = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendEmailToDelegatedOwners) && !is_bool($sendEmailToDelegatedOwners)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sendEmailToDelegatedOwners)), __LINE__);
        }
        $this->sendEmailToDelegatedOwners = $sendEmailToDelegatedOwners;
        return $this;
    }
    /**
     * Get gmUser value
     * @return \StructType\GUMUser|null
     */
    public function getGmUser()
    {
        return $this->gmUser;
    }
    /**
     * Set gmUser value
     * @param \StructType\GUMUser $gmUser
     * @return \StructType\CreateUserDefaultEmail
     */
    public function setGmUser(\StructType\GUMUser $gmUser = null)
    {
        $this->gmUser = $gmUser;
        return $this;
    }
    /**
     * Get myCred value
     * @return \StructType\Credential|null
     */
    public function getMyCred()
    {
        return $this->myCred;
    }
    /**
     * Set myCred value
     * @param \StructType\Credential $myCred
     * @return \StructType\CreateUserDefaultEmail
     */
    public function setMyCred(\StructType\Credential $myCred = null)
    {
        $this->myCred = $myCred;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateUserDefaultEmail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
