<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GUMUser StructType
 * @subpackage Structs
 */
class GUMUser extends AbstractStructBase
{
    /**
     * The AdditionalAttributes
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfAttribute
     */
    public $AdditionalAttributes;
    /**
     * The FirstName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FirstName;
    /**
     * The LastName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LastName;
    /**
     * The Email
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Email;
    /**
     * The Organization
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Organization;
    /**
     * The Territory
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Territory;
    /**
     * Constructor method for GUMUser
     * @uses GUMUser::setAdditionalAttributes()
     * @uses GUMUser::setFirstName()
     * @uses GUMUser::setLastName()
     * @uses GUMUser::setEmail()
     * @uses GUMUser::setOrganization()
     * @uses GUMUser::setTerritory()
     * @param \ArrayType\ArrayOfAttribute $additionalAttributes
     * @param string $firstName
     * @param string $lastName
     * @param string $email
     * @param string $organization
     * @param string $territory
     */
    public function __construct(\ArrayType\ArrayOfAttribute $additionalAttributes = null, $firstName = null, $lastName = null, $email = null, $organization = null, $territory = null)
    {
        $this
            ->setAdditionalAttributes($additionalAttributes)
            ->setFirstName($firstName)
            ->setLastName($lastName)
            ->setEmail($email)
            ->setOrganization($organization)
            ->setTerritory($territory);
    }
    /**
     * Get AdditionalAttributes value
     * @return \ArrayType\ArrayOfAttribute|null
     */
    public function getAdditionalAttributes()
    {
        return $this->AdditionalAttributes;
    }
    /**
     * Set AdditionalAttributes value
     * @param \ArrayType\ArrayOfAttribute $additionalAttributes
     * @return \StructType\GUMUser
     */
    public function setAdditionalAttributes(\ArrayType\ArrayOfAttribute $additionalAttributes = null)
    {
        $this->AdditionalAttributes = $additionalAttributes;
        return $this;
    }
    /**
     * Get FirstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->FirstName;
    }
    /**
     * Set FirstName value
     * @param string $firstName
     * @return \StructType\GUMUser
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($firstName)), __LINE__);
        }
        $this->FirstName = $firstName;
        return $this;
    }
    /**
     * Get LastName value
     * @return string|null
     */
    public function getLastName()
    {
        return $this->LastName;
    }
    /**
     * Set LastName value
     * @param string $lastName
     * @return \StructType\GUMUser
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastName)), __LINE__);
        }
        $this->LastName = $lastName;
        return $this;
    }
    /**
     * Get Email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param string $email
     * @return \StructType\GUMUser
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($email)), __LINE__);
        }
        $this->Email = $email;
        return $this;
    }
    /**
     * Get Organization value
     * @return string|null
     */
    public function getOrganization()
    {
        return $this->Organization;
    }
    /**
     * Set Organization value
     * @param string $organization
     * @return \StructType\GUMUser
     */
    public function setOrganization($organization = null)
    {
        // validation for constraint: string
        if (!is_null($organization) && !is_string($organization)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($organization)), __LINE__);
        }
        $this->Organization = $organization;
        return $this;
    }
    /**
     * Get Territory value
     * @return string|null
     */
    public function getTerritory()
    {
        return $this->Territory;
    }
    /**
     * Set Territory value
     * @param string $territory
     * @return \StructType\GUMUser
     */
    public function setTerritory($territory = null)
    {
        // validation for constraint: string
        if (!is_null($territory) && !is_string($territory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($territory)), __LINE__);
        }
        $this->Territory = $territory;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GUMUser
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
