<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RemoveDelegatedOwner StructType
 * @subpackage Structs
 */
class RemoveDelegatedOwner extends AbstractStructBase
{
    /**
     * The guidToUpdate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $guidToUpdate;
    /**
     * The guidToRemove
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $guidToRemove;
    /**
     * The myCred
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Credential
     */
    public $myCred;
    /**
     * Constructor method for RemoveDelegatedOwner
     * @uses RemoveDelegatedOwner::setGuidToUpdate()
     * @uses RemoveDelegatedOwner::setGuidToRemove()
     * @uses RemoveDelegatedOwner::setMyCred()
     * @param string $guidToUpdate
     * @param string $guidToRemove
     * @param \StructType\Credential $myCred
     */
    public function __construct($guidToUpdate = null, $guidToRemove = null, \StructType\Credential $myCred = null)
    {
        $this
            ->setGuidToUpdate($guidToUpdate)
            ->setGuidToRemove($guidToRemove)
            ->setMyCred($myCred);
    }
    /**
     * Get guidToUpdate value
     * @return string|null
     */
    public function getGuidToUpdate()
    {
        return $this->guidToUpdate;
    }
    /**
     * Set guidToUpdate value
     * @param string $guidToUpdate
     * @return \StructType\RemoveDelegatedOwner
     */
    public function setGuidToUpdate($guidToUpdate = null)
    {
        // validation for constraint: string
        if (!is_null($guidToUpdate) && !is_string($guidToUpdate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($guidToUpdate)), __LINE__);
        }
        $this->guidToUpdate = $guidToUpdate;
        return $this;
    }
    /**
     * Get guidToRemove value
     * @return string|null
     */
    public function getGuidToRemove()
    {
        return $this->guidToRemove;
    }
    /**
     * Set guidToRemove value
     * @param string $guidToRemove
     * @return \StructType\RemoveDelegatedOwner
     */
    public function setGuidToRemove($guidToRemove = null)
    {
        // validation for constraint: string
        if (!is_null($guidToRemove) && !is_string($guidToRemove)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($guidToRemove)), __LINE__);
        }
        $this->guidToRemove = $guidToRemove;
        return $this;
    }
    /**
     * Get myCred value
     * @return \StructType\Credential|null
     */
    public function getMyCred()
    {
        return $this->myCred;
    }
    /**
     * Set myCred value
     * @param \StructType\Credential $myCred
     * @return \StructType\RemoveDelegatedOwner
     */
    public function setMyCred(\StructType\Credential $myCred = null)
    {
        $this->myCred = $myCred;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RemoveDelegatedOwner
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
