<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateGroup StructType
 * @subpackage Structs
 */
class UpdateGroup extends AbstractStructBase
{
    /**
     * The guid
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $guid;
    /**
     * The myAttrs
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfAttribute
     */
    public $myAttrs;
    /**
     * The myCred
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Credential
     */
    public $myCred;
    /**
     * Constructor method for UpdateGroup
     * @uses UpdateGroup::setGuid()
     * @uses UpdateGroup::setMyAttrs()
     * @uses UpdateGroup::setMyCred()
     * @param string $guid
     * @param \ArrayType\ArrayOfAttribute $myAttrs
     * @param \StructType\Credential $myCred
     */
    public function __construct($guid = null, \ArrayType\ArrayOfAttribute $myAttrs = null, \StructType\Credential $myCred = null)
    {
        $this
            ->setGuid($guid)
            ->setMyAttrs($myAttrs)
            ->setMyCred($myCred);
    }
    /**
     * Get guid value
     * @return string|null
     */
    public function getGuid()
    {
        return $this->guid;
    }
    /**
     * Set guid value
     * @param string $guid
     * @return \StructType\UpdateGroup
     */
    public function setGuid($guid = null)
    {
        // validation for constraint: string
        if (!is_null($guid) && !is_string($guid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($guid)), __LINE__);
        }
        $this->guid = $guid;
        return $this;
    }
    /**
     * Get myAttrs value
     * @return \ArrayType\ArrayOfAttribute|null
     */
    public function getMyAttrs()
    {
        return $this->myAttrs;
    }
    /**
     * Set myAttrs value
     * @param \ArrayType\ArrayOfAttribute $myAttrs
     * @return \StructType\UpdateGroup
     */
    public function setMyAttrs(\ArrayType\ArrayOfAttribute $myAttrs = null)
    {
        $this->myAttrs = $myAttrs;
        return $this;
    }
    /**
     * Get myCred value
     * @return \StructType\Credential|null
     */
    public function getMyCred()
    {
        return $this->myCred;
    }
    /**
     * Set myCred value
     * @param \StructType\Credential $myCred
     * @return \StructType\UpdateGroup
     */
    public function setMyCred(\StructType\Credential $myCred = null)
    {
        $this->myCred = $myCred;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
