<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateGroupDisplayedOwner StructType
 * @subpackage Structs
 */
class UpdateGroupDisplayedOwner extends AbstractStructBase
{
    /**
     * The groupGuid
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $groupGuid;
    /**
     * The guidToAdd
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $guidToAdd;
    /**
     * The myCred
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Credential
     */
    public $myCred;
    /**
     * Constructor method for UpdateGroupDisplayedOwner
     * @uses UpdateGroupDisplayedOwner::setGroupGuid()
     * @uses UpdateGroupDisplayedOwner::setGuidToAdd()
     * @uses UpdateGroupDisplayedOwner::setMyCred()
     * @param string $groupGuid
     * @param string $guidToAdd
     * @param \StructType\Credential $myCred
     */
    public function __construct($groupGuid = null, $guidToAdd = null, \StructType\Credential $myCred = null)
    {
        $this
            ->setGroupGuid($groupGuid)
            ->setGuidToAdd($guidToAdd)
            ->setMyCred($myCred);
    }
    /**
     * Get groupGuid value
     * @return string|null
     */
    public function getGroupGuid()
    {
        return $this->groupGuid;
    }
    /**
     * Set groupGuid value
     * @param string $groupGuid
     * @return \StructType\UpdateGroupDisplayedOwner
     */
    public function setGroupGuid($groupGuid = null)
    {
        // validation for constraint: string
        if (!is_null($groupGuid) && !is_string($groupGuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($groupGuid)), __LINE__);
        }
        $this->groupGuid = $groupGuid;
        return $this;
    }
    /**
     * Get guidToAdd value
     * @return string|null
     */
    public function getGuidToAdd()
    {
        return $this->guidToAdd;
    }
    /**
     * Set guidToAdd value
     * @param string $guidToAdd
     * @return \StructType\UpdateGroupDisplayedOwner
     */
    public function setGuidToAdd($guidToAdd = null)
    {
        // validation for constraint: string
        if (!is_null($guidToAdd) && !is_string($guidToAdd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($guidToAdd)), __LINE__);
        }
        $this->guidToAdd = $guidToAdd;
        return $this;
    }
    /**
     * Get myCred value
     * @return \StructType\Credential|null
     */
    public function getMyCred()
    {
        return $this->myCred;
    }
    /**
     * Set myCred value
     * @param \StructType\Credential $myCred
     * @return \StructType\UpdateGroupDisplayedOwner
     */
    public function setMyCred(\StructType\Credential $myCred = null)
    {
        $this->myCred = $myCred;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateGroupDisplayedOwner
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
